Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4901)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1)
@@ -552,157 +215,70 @@
           WRITE( action, '(A)' )  'galilei_transformation = .TRUE.'
        ENDIF
+       IF ( cloud_physics )  THEN
+          WRITE( action, '(A)' )  'cloud_physics = .TRUE.'
+       ENDIF
        IF ( cloud_droplets )  THEN
           WRITE( action, '(A)' )  'cloud_droplets = .TRUE.'
        ENDIF
-       IF ( .NOT. constant_flux_layer  .AND.  topography /= 'closed_channel' )  THEN
-          WRITE( action, '(A)' )  'constant_flux_layer = .FALSE.'
+       IF ( moisture )  THEN
+          WRITE( action, '(A)' )  'moisture = .TRUE.'
+       ENDIF
+       IF ( .NOT. prandtl_layer )  THEN
+          WRITE( action, '(A)' )  'prandtl_layer = .FALSE.'
        ENDIF
        IF ( action /= ' ' )  THEN
-          message_string = 'The specified topography does not allow ' // TRIM( action )
-          CALL message( 'check_parameters', 'PA0014', 1, 2, 0, 6, 0 )
-       ENDIF
-!
-!--    Check illegal/untested parameter combinations for closed channel
-       If ( topography == 'closed_channel' )  THEN
-          symmetry_flag = 1
-          message_string = 'Bottom and top boundary are treated equal'
-          CALL message( 'check_parameters', 'PA0699', 0, 0, 0, 6, 0 )
-
-          IF ( dz(1) /= dz(COUNT( dz /= -1.0_wp ))  .OR.  dz_stretch_level /= -9999999.9_wp)  THEN
-             WRITE( message_string, * )  'dz should be equal close to the ' //                     &
-                                         'boundaries due to symmetrical problem'
-             CALL message( 'check_parameters', 'PA0700', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( constant_flux_layer )  THEN
-             WRITE( message_string, * )  'A constant flux layer is not ' //                        &
-                                         'allowed if a closed channel shall be used'
-             CALL message( 'check_parameters', 'PA0701', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( ocean_mode )  THEN
-             WRITE( message_string, * )  'The ocean mode is not allowed if ' //                    &
-                                         'a closed channel shall be used'
-             CALL message( 'check_parameters', 'PA0702', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( momentum_advec /= 'ws-scheme'  .OR.                                                 &
-               scalar_advec /= 'ws-scheme' )  THEN
-             WRITE( message_string, * )  'A closed channel require the upwind scheme of Wicker' // &
-                                         ' and Skamarock as the advection scheme'
-             CALL message( 'check_parameters', 'PA0703', 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDIF
-    ENDIF
-
-!
-!-- Check approximation
-    IF ( TRIM( approximation ) /= 'boussinesq'  .AND.  TRIM( approximation ) /= 'anelastic' )  THEN
-       message_string = 'unknown approximation: approximation = "' // TRIM( approximation ) // '"'
-       CALL message( 'check_parameters', 'PA0446', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check approximation requirements
-    IF ( TRIM( approximation ) == 'anelastic'  .AND.  TRIM( momentum_advec ) /= 'ws-scheme' )  THEN
-       message_string = 'Anelastic approximation requires momentum_advec = "ws-scheme"'
-       CALL message( 'check_parameters', 'PA0447', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( TRIM( approximation ) == 'anelastic'  .AND.  TRIM( psolver ) == 'multigrid' )  THEN
-       message_string = 'Anelastic approximation currently only supports psolver = "poisfft", ' // &
-                        'psolver = "sor" and psolver = "multigrid_noopt"'
-       CALL message( 'check_parameters', 'PA0448', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( TRIM( approximation ) == 'anelastic'  .AND.  conserve_volume_flow )  THEN
-       message_string = 'Anelastic approximation is not allowed with ' //                          &
-                        'conserve_volume_flow = .TRUE.'
-       CALL message( 'check_parameters', 'PA0449', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check flux input mode
-    IF ( TRIM( flux_input_mode ) /= 'dynamic'  .AND.  TRIM( flux_input_mode ) /= 'kinematic'       &
-         .AND.  TRIM( flux_input_mode ) /= 'approximation-specific' )  THEN
-       message_string = 'unknown flux input mode: flux_input_mode = "' //                          &
-                        TRIM( flux_input_mode ) // '"'
-       CALL message( 'check_parameters', 'PA0450', 1, 2, 0, 6, 0 )
-    ENDIF
-!
-!-- Set flux input mode according to approximation if applicable
-    IF ( TRIM( flux_input_mode ) == 'approximation-specific' )  THEN
-       IF ( TRIM( approximation ) == 'anelastic' )  THEN
-          flux_input_mode = 'dynamic'
-       ELSEIF ( TRIM( approximation ) == 'boussinesq' )  THEN
-          flux_input_mode = 'kinematic'
-       ENDIF
-    ENDIF
-
-!
-!-- Check flux output mode
-    IF ( TRIM( flux_output_mode ) /= 'dynamic'  .AND.  TRIM( flux_output_mode ) /= 'kinematic'     &
-         .AND.  TRIM( flux_output_mode ) /= 'approximation-specific' )  THEN
-       message_string = 'unknown flux output mode: flux_output_mode = "' //                        &
-                        TRIM( flux_output_mode ) // '"'
-       CALL message( 'check_parameters', 'PA0451', 1, 2, 0, 6, 0 )
-    ENDIF
-!
-!-- Set flux output mode according to approximation if applicable
-    IF ( TRIM( flux_output_mode ) == 'approximation-specific' )  THEN
-       IF ( TRIM( approximation ) == 'anelastic' )  THEN
-          flux_output_mode = 'dynamic'
-       ELSEIF ( TRIM( approximation ) == 'boussinesq' )  THEN
-          flux_output_mode = 'kinematic'
-       ENDIF
-    ENDIF
-
-
-!
-!-- When the land- or urban-surface model is used, the flux output must be dynamic.
-    IF ( land_surface  .OR.  urban_surface )  THEN
-       flux_output_mode = 'dynamic'
-    ENDIF
-
-!
-!-- Set the flux output units according to flux_output_mode
-    IF ( TRIM( flux_output_mode ) == 'kinematic' )  THEN
-        heatflux_output_unit              = 'K m/s'
-        waterflux_output_unit             = 'kg/kg m/s'
-        momentumflux_output_unit          = 'm2/s2'
-    ELSEIF ( TRIM( flux_output_mode ) == 'dynamic' )  THEN
-        heatflux_output_unit              = 'W/m2'
-        waterflux_output_unit             = 'W/m2'
-        momentumflux_output_unit          = 'N/m2'
-    ENDIF
-
-!
-!-- set time series output units for fluxes
-    dots_unit(14:16) = TRIM( heatflux_output_unit )
-    dots_unit(21)    = TRIM( waterflux_output_unit )
-    dots_unit(19:20) = TRIM( momentumflux_output_unit )
-
-!
-!-- Add other module specific timeseries
-    CALL module_interface_check_data_output_ts( dots_max, dots_num, dots_label, dots_unit )
-
-!
-!-- Check if maximum number of allowed timeseries is exceeded
-    IF ( dots_num > dots_max )  THEN
-       WRITE( message_string, * ) 'number of time series quantities exceeds',                      &
-                                  ' its maximum of dots_max = ', dots_max,                         &
-                                  '&Please increase dots_max in netcdf_interface_mod.f90.'
-       CALL message( 'check_parameters', 'PA0194', 1, 2, 0, 6, 0 )
-    ENDIF
-
+          IF ( myid == 0 )  THEN
+             PRINT*, '+++ check_parameters:'
+             PRINT*, '    a non-flat topography does not allow ', TRIM( action )
+          ENDIF
+          CALL local_stop
+       ENDIF
+    ENDIF
 !
 !-- Check whether there are any illegal values
 !-- Pressure solver:
-    IF ( psolver /= 'poisfft'  .AND.  psolver /= 'sor'  .AND.  psolver /= 'multigrid'  .AND.       &
-         psolver /= 'multigrid_noopt' )  THEN
-       message_string = 'unknown solver for perturbation pressure: psolver' //                     &
-                        ' = "' // TRIM( psolver ) // '"'
-       CALL message( 'check_parameters', 'PA0016', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( psolver(1:9) == 'multigrid' )  THEN
+    IF ( psolver /= 'poisfft'  .AND.  psolver /= 'poisfft_hybrid'  .AND. &
+         psolver /= 'sor'  .AND.  psolver /= 'multigrid' )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    unknown solver for perturbation pressure: psolver=', &
+                  psolver
+       ENDIF
+       CALL local_stop
+    ENDIF
+
+#if defined( __parallel )
+    IF ( psolver == 'poisfft_hybrid'  .AND.  pdims(2) /= 1 )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    psolver="', TRIM( psolver ), '" only works for a ', &
+                       '1d domain-decomposition along x'
+          PRINT*, '    please do not set npey/=1 in the parameter file'
+       ENDIF
+       CALL local_stop
+    ENDIF
+    IF ( ( psolver == 'poisfft_hybrid'  .OR.  psolver == 'multigrid' )  .AND.  &
+         ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz ) )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    psolver="', TRIM( psolver ), '" does not work for ', &
+                       'subdomains with unequal size'
+          PRINT*, '    please set grid_matching = ''strict'' in the parameter',&
+                       ' file'
+       ENDIF
+       CALL local_stop
+    ENDIF
+#else
+    IF ( psolver == 'poisfft_hybrid' )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    psolver="', TRIM( psolver ), '" only works for a ', &
+                       'parallel environment'
+       ENDIF
+       CALL local_stop
+    ENDIF
+#endif
+
+    IF ( psolver == 'multigrid' )  THEN
        IF ( cycle_mg == 'w' )  THEN
           gamma_mg = 2
@@ -710,60 +286,60 @@
           gamma_mg = 1
        ELSE
-          message_string = 'unknown multigrid cycle: cycle_mg = "' //  TRIM( cycle_mg ) // '"'
-          CALL message( 'check_parameters', 'PA0020', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDIF
-
-    IF ( fft_method /= 'singleton-algorithm'  .AND.  fft_method /= 'temperton-algorithm'  .AND.    &
-         fft_method /= 'fftw'                 .AND.  fft_method /= 'system-specific' )  THEN
-       message_string = 'unknown fft-algorithm: fft_method = "' // TRIM( fft_method ) // '"'
-       CALL message( 'check_parameters', 'PA0021', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF( momentum_advec == 'ws-scheme' .AND.  .NOT. call_psolver_at_all_substeps  ) THEN
-        message_string = 'psolver must be called at each RK3 substep when "'//                     &
-                         TRIM(momentum_advec) // ' "is used for momentum_advec'
-        CALL message( 'check_parameters', 'PA0344', 1, 2, 0, 6, 0 )
-    END IF
+          IF ( myid == 0 )  THEN
+             PRINT*, '+++ check_parameters:'
+             PRINT*, '    unknown multigrid cycle: cycle_mg=', cycle_mg
+          ENDIF
+          CALL local_stop
+       ENDIF
+    ENDIF
+
+    IF ( fft_method /= 'singleton-algorithm'  .AND.  &
+         fft_method /= 'temperton-algorithm'  .AND.  &
+         fft_method /= 'system-specific' )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    unknown fft-algorithm: fft_method=', fft_method
+       ENDIF
+       CALL local_stop
+    ENDIF
+
 !
 !-- Advection schemes:
-    IF ( momentum_advec /= 'pw-scheme'  .AND.  momentum_advec /= 'ws-scheme'  .AND.                &
-         momentum_advec /= 'up-scheme' )  THEN
-       message_string = 'unknown advection scheme: momentum_advec = "' //                          &
-                        TRIM( momentum_advec ) // '"'
-       CALL message( 'check_parameters', 'PA0022', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( ( momentum_advec == 'ws-scheme' .OR. scalar_advec == 'ws-scheme' )                        &
-         .AND. ( timestep_scheme == 'euler' .OR.  timestep_scheme == 'runge-kutta-2' ) )  THEN
-       message_string = 'momentum_advec or scalar_advec = "' // TRIM( momentum_advec ) //          &
-                        '" is not allowed with timestep_scheme = "' //                             &
-                        TRIM( timestep_scheme ) // '"'
-       CALL message( 'check_parameters', 'PA0023', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( scalar_advec /= 'pw-scheme'  .AND.  scalar_advec /= 'ws-scheme'  .AND.                    &
-         scalar_advec /= 'bc-scheme'  .AND.  scalar_advec /= 'up-scheme' )  THEN
-       message_string = 'unknown advection scheme: scalar_advec = "' // TRIM( scalar_advec ) // '"'
-       CALL message( 'check_parameters', 'PA0024', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( scalar_advec == 'bc-scheme'  .AND.  loop_optimization == 'cache' )  THEN
-       message_string = 'advection_scheme scalar_advec = "' // TRIM( scalar_advec ) //             &
-                        '" not implemented for loop_optimization = "' //                           &
-                        TRIM( loop_optimization ) // '"'
-       CALL message( 'check_parameters', 'PA0026', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( use_sgs_for_particles  .AND.  .NOT. cloud_droplets  .AND.  .NOT. use_upstream_for_tke     &
-         .AND.  scalar_advec /= 'ws-scheme' )  THEN
+    IF ( momentum_advec /= 'pw-scheme' .AND. momentum_advec /= 'ups-scheme' ) &
+    THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  unknown advection ', &
+                                 'scheme: momentum_advec=', momentum_advec
+       CALL local_stop
+    ENDIF
+    IF ( ( momentum_advec == 'ups-scheme'  .OR.  scalar_advec == 'ups-scheme' )&
+                                      .AND.  timestep_scheme /= 'euler' )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  momentum_advec=', &
+                                 momentum_advec, ' is not allowed with ', &
+                                 'timestep_scheme=', timestep_scheme
+       CALL local_stop
+    ENDIF
+
+    IF ( scalar_advec /= 'pw-scheme'  .AND.  scalar_advec /= 'bc-scheme'  .AND.&
+         scalar_advec /= 'ups-scheme' )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  unknown advection ', &
+                                 'scheme: scalar_advec=', scalar_advec
+       CALL local_stop
+    ENDIF
+
+    IF ( use_sgs_for_particles  .AND.  .NOT. use_upstream_for_tke )  THEN
        use_upstream_for_tke = .TRUE.
-       message_string = 'use_upstream_for_tke is set to .TRUE. because ' //                        &
-                        'use_sgs_for_particles = .TRUE. and scalar_advec /= ws-scheme'
-       CALL message( 'check_parameters', 'PA0025', 0, 1, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Set LOGICAL switches to enhance performance
-    IF ( momentum_advec == 'ws-scheme' )  ws_scheme_mom = .TRUE.
-    IF ( scalar_advec   == 'ws-scheme' )  ws_scheme_sca = .TRUE.
-
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ WARNING: check_parameters:  use_upstream_for_tke set ', &
+                       '.TRUE. because use_sgs_for_particles = .TRUE.'
+       ENDIF
+    ENDIF
+
+    IF ( use_upstream_for_tke  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:  use_upstream_for_tke = .TRUE. ', &
+                       'not allowed with timestep_scheme=', timestep_scheme
+       ENDIF
+       CALL local_stop
+    ENDIF
 
 !
